import React, { Component, useState, useEffect } from 'react';
import { Form, Icon, Input, Button, DatePicker, Select, Card, Row, Col, Pagination, Alert, Table, Avatar, Radio, Modal, Descriptions } from 'antd';
import moment from 'moment';
import EChart from '../../../components/EchartsTest/EChart';
import request from '../../../utils/request';
import apis from '../../../services/apis';
import StatsChart from './component/StatsChart';
import router from 'umi/router';


const { RangePicker } = DatePicker;
const { Option } = Select

let daterange = []
let tableTitle = ['类型']

class buildingStats extends React.Component {

  constructor(props) {
    super(props)
    this.state = {
      barData: {},
      tableData: [],
      userType: 'all',
      endDate: {},
      startDate: {}
    }
  }

  componentDidMount() {
    this.getBarData(moment().subtract(7, 'day').toDate(),new Date())
    this.getTableData(moment().subtract(7, 'day').toDate(),new Date())
    // this.setState({ endDate: new Date(), startDate: moment().subtract(7, 'day').toDate() })
    
  }

  // 获取图表数据
  getBarData = (startDate, endDate) => {
    request({ ...apis.stats.barList, params: { startDate, endDate } }).then((data) => {
        console.log(data)
        this.setState({barData: data})
      })
  }

  //获取表格数据
  getTableData = (startDate, endDate) => {
    console.log(startDate,endDate,"时间2")
  }

  formatDate = (start, end) => {
    const tempStartDate = `${moment(start).format('YYYY-MM-DDT00:00:00.000')}Z`
    const tempEndDate = `${moment(end).format('YYYY-MM-DDT23:59:59.999')}Z`
    return { startDate: tempStartDate, endDate: tempEndDate }
  }

  onChangetime = (_dates, dateStrings) => {
    daterange[0] = `${moment(dateStrings[0]).format('YYYY-MM-DDT00:00:00.000')}Z`
    daterange[1] = `${moment(dateStrings[1]).format('YYYY-MM-DDT23:59:59.999')}Z`
  }

  handleSubmit = (e, props) => {

    e.preventDefault();

  }

  getDataOf = (days) => {
    this.getBarData(moment().subtract(days, 'day').toDate(),new Date())
    // this.setState({ endDate: new Date(), startDate: moment().subtract(days, 'day').toDate() })
  }

  datalist = () => {
    this.getBarData(daterange[0] === '' ? moment().subtract(7, 'day').toDate() : daterange[0],daterange[1] === '' ? new Date() : daterange[1])
    // this.setState({ 
    //   endDate: daterange[1] === '' ? new Date() : daterange[1],
    //   startDate: daterange[0] === '' ? moment().subtract(7, 'day').toDate() : daterange[0],
    // })
    
  }

  onSuccess = e => {
    this.setState({ dataSoures: e }, () => {
      this.onTabledatas(e)
    })
  }

  onTabledatas = (e) => {
    console.log('this.state.userType: ', this.state.userType)
    e.tdWxDicts.map(x => {
        columns = columns.filter(y => y.key != x.sceneType).concat({
          title: x.sceneAlias,
          dataIndex: x.sceneType,
          key: x.sceneType,
        })
    })
    const data = (e.list || []).reduce((acc, item) => {
      const { sceneType, fromNum, registeredNum, createTime } = item
      const num = this.state.userType === 'registered' ? registeredNum : fromNum
      acc[createTime] = { ...acc[createTime], ...item, [`${sceneType}`]: !num ? 0 : num }
      return acc
    }, {})

    const dictData =  e.tdWxDicts.reduce((acc,item,index) => {
      const { sceneType } = item
      acc[sceneType] = 0
      return acc
    },{})

    const tableData = Object.keys(data).map(k => data[k]).reduce((acc,item,index) => {
      acc[index] = { ...dictData, ...item }
      return acc
    },[])

    this.setState({ tableData })

  }

  handleSelectChange = (e) => {
    this.setState({ userType: e }, () => {
      this.onTabledatas(this.state.dataSoures)
    })
  }

  render() {
    return (
    <div>
      <Radio.Group buttonStyle="solid" defaultValue="a">
          <Radio.Button value="c" onClick={() => this.getDataOf(0)}>今日</Radio.Button>
          <Radio.Button value="a" onClick={() => this.getDataOf(7)}>最近7天</Radio.Button>
          <Radio.Button value="b" onClick={() => this.getDataOf(30)}>最近1月</Radio.Button>
        </Radio.Group>
        <RangePicker
          style={{ paddingLeft: '30px' }}
          ranges={{
            Today: [moment(), moment()],
            'This Month': [moment().startOf('month'), moment().endOf('month')],
          }}
          onChange={(_dates, dateStrings) => this.onChangetime(_dates, dateStrings)}
        />
        <Button type="primary" htmlType="submit" style={{ marginLeft: '30px' }} onClick={() => this.datalist()}>
          查询
        </Button>
        <Button type="danger" onClick={() => router.go(-1)} style={{ marginBottom: '18px', marginLeft: '30px' }}>重置</Button>

        <Row>
            <Col span={12}>
                <StatsChart title="项目公客排行" data={this.state.barData.gkBarMap} />
            </Col>
            <Col span={12}>
                <StatsChart title="项目私客排行" data={this.state.barData.skBarMap} />
            </Col>
        </Row>
        <Row>
            <Col span={12}>
                <StatsChart title="项目访问人数排行" subtext="项目详情访问情况" data={this.state.barData.wgBarMap} />
            </Col>
            <Col span={12}>
                <StatsChart title="项目访问次数排行" subtext="项目详情访问情况" data={this.state.barData.fwBarMap} />
            </Col>
        </Row>
         
        <Select style={{ width: '180px' }} placeholder="所有用户" onChange={(e) => this.handleSelectChange(e)}>
        <Option value='all'>所有用户</Option>
        <Option value='registered'>注册用户</Option>
        </Select>
  
          {/* <Table style={{marginTop:'20px'}} dataSource={this.state.tableData} columns={columns} pagination={false} scroll={{ y: 500 }}></Table> */}
    </div>
    )
  }
}

export default buildingStats
